/** ###################################################################
**     Filename    : ProcessorExpert.c
**     Project     : ProcessorExpert
**     Processor   : MC56F84789VLL
**     Version     : Driver 01.14
**     Compiler    : Metrowerks DSP C Compiler
**     Date/Time   : 2012-04-26, 15:49, # CodeGen: 0
**     Abstract    :
**         Main module.
**         This module contains user's application code.
**     Settings    :
**     Contents    :
**         No public methods
**
** ###################################################################*/
/* MODULE ProcessorExpert */


/* Including needed modules to compile this module/procedure */
#include "Cpu.h"
#include "Events.h"
#include "TMR1.h"
#include "TMR2.h"
#include "TMR3.h"
#include "TMR4.h"
/* Including shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

void main(void)
{
  /* Write your local variable definition here */
	word b0,b1,b2,b3;
	unsigned long i ;
	unsigned long start,stop,cycles ;

  /*** Processor Expert internal initialization. DON'T REMOVE THIS CODE!!! ***/
  PE_low_level_init();
  /*** End of Processor Expert internal initialization.                    ***/

  /* Write your code here */
/* code to measure the execution time. */

	b0 = PESL(TMRB0, QT_READ_COUNTER_REG, ...);
	b1 = PESL(TMRB1, QT_READ_HOLD_REG, ...); // reading counter any counter reg freezes the hold regs!
	b2 = PESL(TMRB2, QT_READ_HOLD_REG, ...);
	b3 = PESL(TMRB3, QT_READ_HOLD_REG, ...);
	if (b2 || b3 ){asm{debughlt}} ; // halt on timer overflows.
	start = ((unsigned long) b0 ) + ((unsigned long) b1 << 16) ;

  
  
  for(i=0;i<100000;i++) {
	  
	 asm {nop
		 nop
		 nop
		 nop
		 nop
		 nop
		 nop
		 nop
		 nop
		 nop
		 
	 }
	  
	  
	  
	  
  }
  
	b0 = PESL(TMRB0, QT_READ_COUNTER_REG, ...);
	b1 = PESL(TMRB1, QT_READ_HOLD_REG, ...); // reading counter any counter reg freezes the hold regs!
	b2 = PESL(TMRB2, QT_READ_HOLD_REG, ...);
	b3 = PESL(TMRB3, QT_READ_HOLD_REG, ...);
	if (b2 || b3 ){asm{debughlt}} ; // halt on timer overflows.
	stop = ((unsigned long) b0 ) + ((unsigned long) b1 << 16) ;
	cycles = stop - start ;
    asm(debughlt);
  
}

/* END ProcessorExpert */
/*
** ###################################################################
**
**     This file was created by Processor Expert 5.3 [05.01]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
