/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : EC81.h
**     Project     : ProcessorExpert
**     Processor   : MC56F84789VLL
**     Component   : EventCntr8
**     Version     : Component 02.100, Driver 02.06, CPU db: 3.50.001
**     Compiler    : Metrowerks DSP C Compiler
**     Date/Time   : 2012-07-05, 11:38, # CodeGen: 12
**     Abstract    :
**         This component "EventCntr8" implements an 8-bit event counter.
**         It counts the external events (specified edges of the external
**         signal). It uses a hardware counter that can have different width.
**         In that case the counter will be extended or taperred to 8 bits.
**     Settings    :
**         Timer name                  : TMRA1 [16-bit]
**         Used input pin              : 
**             ----------------------------------------------------
**                Number (on package)  |    Name
**             ----------------------------------------------------
**                       12            |  GPIOC4/TA1/CMPB_O/XB_IN8/EWM_OUT_B
**             ----------------------------------------------------
**         Counter register            : TMRA_1_CNTR [E155]
**         Mode register               : TMRA_1_CTRL [E156]
**         Run register                : TMRA_1_CTRL [E156]
**     Contents    :
**         Enable       - byte EC81_Enable(void);
**         Reset        - byte EC81_Reset(void);
**         GetNumEvents - byte EC81_GetNumEvents(byte *Value);
**
**     Copyright : 1997 - 2012 Freescale Semiconductor, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/

#ifndef __EC81
#define __EC81

/* MODULE EC81. */

/*Include shared modules, which are used for whole project*/
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

#include "Cpu.h"


byte EC81_Enable(void);
/*
** ===================================================================
**     Method      :  EC81_Enable (component EventCntr8)
**
**     Description :
**         This method enables the component: the external events are counted.
**     Parameters  : None
**     Returns     :
**         ---        - Error code
** ===================================================================
*/

byte EC81_Reset(void);
/*
** ===================================================================
**     Method      :  EC81_Reset (component EventCntr8)
**
**     Description :
**         This method resets the external event counter (sets it to zero).
**     Parameters  : None
**     Returns     :
**         ---        - Error code
** ===================================================================
*/

byte EC81_GetNumEvents(byte *Value);
/*
** ===================================================================
**     Method      :  EC81_GetNumEvents (component EventCntr8)
**
**     Description :
**         This method returns the number of the external events.
**     Parameters  :
**         NAME            - DESCRIPTION
**       * Value           - A pointer to the returned number of
**                           the external events
**     Returns     :
**         ---             - Error code, possible codes:
**                           ERR_OK - OK
**                           ERR_OVERFLOW - Timer overflow
** ===================================================================
*/

void EC81_Interrupt(void);
/*
** ===================================================================
**     Method      :  EC81_Interrupt (component EventCntr8)
**
**     Description :
**         The method services the interrupt of the selected peripheral(s)
**         and eventually invokes the beans event(s).
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void EC81_Init(void);
/*
** ===================================================================
**     Method      :  EC81_Init (component EventCntr8)
**
**     Description :
**         Initializes the associated peripheral(s) and the beans 
**         internal variables. The method is called automatically as a 
**         part of the application initialization code.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

/* END EC81. */

#endif /* ifndef __EC81 */
/*
** ###################################################################
**
**     This file was created by Processor Expert 5.3 [05.01]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
