/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : DAC1.h
**     Project     : ProcessorExpert
**     Processor   : MC56F84789VLL
**     Component   : Init_DAC
**     Version     : Component 01.019, Driver 01.07, CPU db: 3.50.001
**     Compiler    : Metrowerks DSP C Compiler
**     Date/Time   : 2012-07-05, 11:51, # CodeGen: 8
**     Abstract    :
**         This bean encapsulates 12-bit Digital to Analog Converter (DAC) interface.
**         DAC features include: 12-bit resolution, 2 microsecond conversion rate,
**         power down mode, output can be routed to internal comparator or off chip
**         DAC can drive 3K ohm, 400pF load, choice of asynchronous or synchronous
**         updates, sync input can be connected to on chip peripherals(PITs, TMRs,
**         PWM reload flag, or GPIO inputs), automatic mode allows the DAC to
**         generate its own output waveforms including square, triangle, and sawtooth
**         waveforms, automatic mode allows programmable period, update rate, and range.
**     Settings    :
**          Component name                                 : DAC1
**          Device                                         : DAC
**          Settings                                       : 
**            Glitch filter                                : Enabled
**            Glitch filter count bits                     : 7
**            Up counting                                  : Disabled
**            Down counting                                : Disabled
**            Automatic mode                               : Disabled
**            Data word justification                      : Right
**            High speed/low speed                         : High speed
**            DMA enable                                   : Disabled
**            Watermark level                              : 2 samples
**          Pins                                           : 
**            Output pin                                   : Enabled
**              Analog output pin                          : GPIOC5/DACO/XB_IN7
**              Analog output pin signal                   : 
**            Synchronous mode                             : Disabled
**          Initialization                                 : 
**            Call Init method                             : yes
**            Power down                                   : no
**            Enable peripheral clock                      : yes
**            DAC data register value                      : 1000
**            DAC minimum register value                   : 0
**            DAC maximum register value                   : 4095
**            DAC step size register value                 : 0
**     Contents    :
**         Init - void DAC1_Init(void);
**
**     Copyright : 1997 - 2012 Freescale Semiconductor, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/

#ifndef __DAC1
#define __DAC1

/* MODULE DAC1. */

/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
/* Include inherited beans */

#include "Cpu.h"




/* PESL device mapping  */
#define DAC1_DEVICE DAC

void DAC1_Init(void);
/*
** ===================================================================
**     Method      :  DAC1_Init (component Init_DAC)
**
**     Description :
**         This method initializes registers of the DAC module
**         according to this Peripheral Initialization Bean settings.
**         Call this method in the user code to initialize the
**         module. By default, the method is called by PE
**         automatically; see <Call Init method> property of the
**         bean for more details.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

/* END DAC1. */

#endif
/* ifndef __DAC1 */
/*
** ###################################################################
**
**     This file was created by Processor Expert 5.3 [05.01]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
