/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : Cpu.h
**     Project     : ProcessorExpert
**     Processor   : MC56F84789VLL
**     Component   : MC56F84789VLL
**     Version     : Component 01.066, Driver 01.00, CPU db: 3.50.001
**     Datasheet   : MC56F847XXRM Rev.0RC 10/201
**     Compiler    : Metrowerks DSP C Compiler
**     Date/Time   : 2012-07-05, 11:57, # CodeGen: 44
**     Abstract    :
**
**     Settings    :
**
**     Contents    :
**         EnableInt   - void Cpu_EnableInt(void);
**         DisableInt  - void Cpu_DisableInt(void);
**         SetWaitMode - void Cpu_SetWaitMode(void);
**         SetStopMode - void Cpu_SetStopMode(void);
**         Delay100US  - asm void Cpu_Delay100US(word us100);
**
**     (c) Freescale Semiconductor
**     2004 All Rights Reserved
**
**     Copyright : 1997 - 2012 Freescale Semiconductor, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/

#ifndef __Cpu_H
#define __Cpu_H

/* MODULE Cpu. */

/* Active PE project configuration */
#define PEcfg_MC56F84789VLL_Internal_PFlash_SDM 1

/* Active CPU bean */
#define PE_CPU_TYPE_MC56F84789VLL

/* Active CPU variant */
#define PE_CPU_VARIANT_MC56F84789VLL

/* Active CPU family */
#define PE_CPU_FAMILY_56800

/* Active CPU subfamily */
#define PE_CPU_SUBFAMILY_56F84xxx

/*Include shared modules, which are used for whole project*/
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
#include "PESL.h"
#include "assert.h"

#ifndef __BWUserType_TShadowRegs
#define __BWUserType_TShadowRegs
  typedef struct {                     /* Shadow register type. */
    int32_t N;                         /* Shadow register N. */
    int16_t N3;                        /* Shadow register N3. */
    int16_t M01;                       /* Shadow register M01. */
    word* R0;                          /* Shadow register R0. */
    word* R1;                          /* Shadow register R1. */
    word* R3;                          /* Shadow register R3. */
    word* R4;                          /* Shadow register R4. */
    word* R5;                          /* Shadow register R5. */
    word* R2;                          /* Shadow register R2. In InitShadowRegs() this register is used to index through TShadowRegs so is placed as last struct item */
  } TShadowRegs;
#endif

/*lint -esym(765,SR_reg,SR_lock,_EntryPoint,_vect,_vectboot) Disable MISRA rule (8.10) checking for symbols (SR_reg,SR_lock,_EntryPoint,_vect,_vectboot). */
/* Global variables */
extern volatile word SR_lock;          /* Lock */
extern volatile word SR_reg;           /* Current value of the SR register */

#define   Cpu_SetStopMode()  asm(STOP) /* Set STOP mode */
/*
** ===================================================================
**     Method      :  Cpu_SetStopMode (component MC56F84789VLL)
**
**     Description :
**         Sets low power mode - Stop mode.
**         For more information about the stop mode see this CPU
**         documentation.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

#define   Cpu_SetWaitMode()  asm(WAIT) /* Set WAIT mode */
/*
** ===================================================================
**     Method      :  Cpu_SetWaitMode (component MC56F84789VLL)
**
**     Description :
**         Sets low power mode - Wait mode.
**         For more information about the wait mode see this CPU
**         documentation.
**         Release from wait mode: Reset or interrupt
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/



/*lint -save  -e586 Disable MISRA rule (2.1) checking. Method is implemented using assembler. */
asm void Cpu_Delay100US(word us100);
/*
** ===================================================================
**     Method      :  Cpu_Delay100US (component MC56F84789VLL)
**
**     Description :
**         This method realizes software delay. The length of delay
**         is at least 100 microsecond multiply input parameter
**         [us100]. As the delay implementation is not based on real
**         clock, the delay time may be increased by interrupt
**         service routines processed during the delay. Adding read
**         wait states for external program memory can cause delay
**         extension as well. The method is independent on selected
**         speed mode.
**     Parameters  :
**         NAME            - DESCRIPTION
**         us100           - Number of 100 us delay repetitions.
**     Returns     : Nothing
** ===================================================================
*/
/*lint -restore Enable MISRA rule (2.1) checking. */

#define   Cpu_DisableInt()  __DI()     /* Disable interrupts */
/*
** ===================================================================
**     Method      :  Cpu_DisableInt (component MC56F84789VLL)
**
**     Description :
**         Disables all maskable interrupts
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

#define   Cpu_EnableInt()  __EI(0)     /* Enable interrupts */
/*
** ===================================================================
**     Method      :  Cpu_EnableInt (component MC56F84789VLL)
**
**     Description :
**         Enables all maskable interrupts
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

void PE_low_level_init(void);
/*
** ===================================================================
**     Method      :  PE_low_level_init (component MC56F84789VLL)
**
**     Description :
**         Initializes beans and provides common register initialization. 
**         The method is called automatically as a part of the 
**         application initialization code.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
void Cpu_Interrupt0(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_HW_RESET_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt1(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_COP_RESET_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt2(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_ILLEGAL_OP_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt3(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_SWI3_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt4(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_OVERFLOW_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt5(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_MISALIGNED_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt6(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_STPCNT_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt7(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_BKPT_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt8(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_TRBUF_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt9(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_TX_REG_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt10(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_RX_REG_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt11(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_BUS_ERR_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt12(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_PLAT_3_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt13(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_PLAT_2_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt14(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_PLAT_1_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt15(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_SWI2_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt16(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_SWI1_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt17(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_SWI0_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt18(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_XBARA_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt19(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_LVI1_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt20(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_OCCS_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt21(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_TMRB_3_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt22(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_TMRB_2_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt23(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_TMRB_1_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt24(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_TMRB_0_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt25(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_TMRA_3_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt26(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_TMRA_2_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt27(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_TMRA_1_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt29(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_ADC12_CC1_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt30(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_ADC12_CC0_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt31(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_ADC12_ERR_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt32(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_ADC16_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt33(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_DMA3_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt34(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_DMA2_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt35(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_DMA1_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt36(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_DMA0_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt37(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_MB_OR_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt38(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_BUS_OFF_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt39(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_ERROR_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt40(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_TX_WARN_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt41(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_RX_WARN_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt42(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_WAKEUP_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt43(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_QSCI2_RERR_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt44(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_QSCI2_RCV_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt45(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_QSCI2_TIDLE_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt46(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_QSCI2_TDRE_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt47(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_QSCI1_RERR_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt48(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_QSCI1_RCV_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt49(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_QSCI1_TIDLE_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt50(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_QSCI1_TDRE_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt51(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_QSCI0_RERR_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt52(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_QSCI0_RCV_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt53(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_QSCI0_TIDLE_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt54(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_QSCI0_TDRE_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt55(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_QSPI2_XMIT_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt56(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_QSPI2_RCV_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt57(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_QSPI1_XMIT_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt58(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_QSPI1_RCV_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt59(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_QSPI0_XMIT_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt60(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_QSPI0_RCV_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt61(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_IIC1_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt62(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_IIC0_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt63(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_eFlexPWMB_FAULT_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt64(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_eFlexPWMB_RERR_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt65(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_eFlexPWMB_RELOAD3_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt66(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_eFlexPWMB_CAP3_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt67(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_eFlexPWMB_CMP3_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt68(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_eFlexPWMB_RELOAD2_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt69(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_eFlexPWMB_CAP2_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt70(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_eFlexPWMB_CMP2_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt71(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_eFlexPWMB_RELOAD1_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt72(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_eFlexPWMB_CAP1_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt73(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_eFlexPWMB_CMP1_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt74(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_eFlexPWMB_RELOAD0_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt75(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_eFlexPWMB_CAP0_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt76(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_eFlexPWMB_CMP0_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt77(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_eFlexPWMA_FAULT_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt78(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_eFlexPWMA_RERR_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt79(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_eFlexPWMA_RELOAD3_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt80(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_eFlexPWMA_CAP_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt81(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_eFlexPWMA_CMP3_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt82(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_eFlexPWMA_RELOAD2_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt83(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_eFlexPWMA_CMP2_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt84(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_eFlexPWMA_RELOAD1_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt85(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_eFlexPWMA_CMP1_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt86(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_eFlexPWMA_RELOAD0_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt87(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_eFlexPWMA_CMP0_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt88(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_FTFL_RDCOL_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt89(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_FTFL_CC_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt90(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_CMPD_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt91(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_CMPC_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt92(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_CMPB_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt93(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_CMPA_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt94(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_PIT1_ROLLOVR_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt96(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_PDB1_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt97(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_PDB0_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt98(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_INDEX_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt99(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_HOME_DOG_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt100(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_COMPARE_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt101(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_GPIOG_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt102(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_GPIOF_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt103(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_GPIOE_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt104(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_GPIOD_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt105(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_GPIOC_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt106(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_GPIOB_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt107(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_GPIOA_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt108(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_COP_INT_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt109(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_EWM_INT_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void Cpu_Interrupt110(void);
/*
** ===================================================================
**     Method      :  Cpu_Interrupt"ivINT_SWILP_No" (component MC56F84789VLL)
**
**     Description :
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/


void _EntryPoint(void);
/*
** ===================================================================
**     Method      :  _EntryPoint (component MC56F84789VLL)
**
**     Description :
**         Initializes the whole system like timing and so on. At the end 
**         of this function, the C startup is invoked to initialize stack,
**         memory areas and so on.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

/* END Cpu. */

#endif
/* __Cpu_H */

/*
** ###################################################################
**
**     This file was created by Processor Expert 5.3 [05.01]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
