/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : SPI1.c
**     Project     : ProcessorExpert
**     Processor   : MC56F84789VLL
**     Component   : Init_SPI
**     Version     : Component 01.066, Driver 01.26, CPU db: 3.50.001
**     Compiler    : Metrowerks DSP C Compiler
**     Date/Time   : 2012-07-05, 12:00, # CodeGen: 11
**     Abstract    :
**         This "Init_SPI" Peripheral Inspector implements the
**         Serial Peripheral Interface module (SPI), basic 
**         initialization and settings.
**     Settings    :
**          Component name                                 : SPI1
**          Device                                         : QSPI0
**          Settings                                       : 
**            Baud rate setting                            : 
**              Clock divisor value                        : 16
**              Baud Divisor Times 2                       : Disabled
**              SPI frequency                              : 6.25 MHz
**            SPI mode                                     : Master
**            Data size                                    : 8 bits
**            Data shift order                             : MSB first
**            Mode fault checking                          : Disabled
**            Clock polarity                               : rising edge
**            Clock phase                                  : first SCLK edge
**            Wired OR mode                                : Disabled
**          SS data                                        : High
**          SS open drain                                  : no open drain
**          SS automatic mode                              : Disabled
**          SS direction                                   : Input
**          SS strobe mode                                 : Disabled
**          SS override                                    : Disabled
**          Wait delay                                     : 0
**          Tx FIFO Watermark                              : 0
**          Rx FIFO Watermark                              : 3
**          FIFO enable                                    : Disabled
**          Stop hold                                      : Disabled
**          Pins                                           : 
**            MISO pin                                     : GPIOC8/MISO0/RXD0/XB_IN9
**            MISO pin signal                              : 
**            MOSI pin                                     : GPIOC10/MOSI0/XB_IN5/MISO0
**            MOSI pin signal                              : 
**            SCLK pin                                     : GPIOC9/SCK0/XB_IN4
**            SCLK pin signal                              : 
**            SS pin                                       : GPIOC7/SS0_B/TXD0
**            SS pin signal                                : 
**          Interrupts/DMA                                 : 
**            Receiver full                                : 
**              Interrupt                                  : INT_QSPI0_RCV
**              Receiver interrupt                         : Disabled
**              Error interrupt                            : Disabled
**              Interrupt priority                         : medium priority
**              ISR name                                   : ISR_Rx
**            Transmitter empty                            : 
**              Interrupt                                  : INT_QSPI0_XMIT
**              Transmitter interrupt                      : Disabled
**              Interrupt priority                         : medium priority
**              ISR name                                   : ISR_Tx
**            DMA                                          : 
**              Receive DMA                                : Disabled
**              Transmit DMA                               : Disabled
**          Initialization                                 : 
**            Call Init method                             : yes
**            Enable peripheral clock                      : yes
**            Enable SPI module                            : yes
**     Contents    :
**         Init - void SPI1_Init(void);
**
**     Copyright : 1997 - 2012 Freescale Semiconductor, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/

/* MODULE SPI1. */

#include "SPI1.h"

/*
** ###################################################################
**
**  The following method(s) must be implemented by the user in one
**  of the following modules:
**
**    #if defined(ISR_Rx_FAST_INT)
**    #pragma interrupt fast
**    #elif defined(ISR_Rx_VECT_TABLE_ISR_FAST_INT)
**    #pragma define_section interrupt_fast "interrupt_fast.text"  RX
**    #pragma section interrupt_fast begin
**    #pragma interrupt fast
**    #else
**    #pragma interrupt
**    #endif
**    void ISR_Rx(void)
**    {
**      // Your interrupt code
**    }
**    #if defined(ISR_Rx_VECT_TABLE_ISR_FAST_INT)
**    #pragma section interrupt_fast end
**    #endif
**
**    #if defined(ISR_Tx_FAST_INT)
**    #pragma interrupt fast
**    #elif defined(ISR_Tx_VECT_TABLE_ISR_FAST_INT)
**    #pragma define_section interrupt_fast "interrupt_fast.text"  RX
**    #pragma section interrupt_fast begin
**    #pragma interrupt fast
**    #else
**    #pragma interrupt
**    #endif
**    void ISR_Tx(void)
**    {
**      // Your interrupt code
**    }
**    #if defined(ISR_Tx_VECT_TABLE_ISR_FAST_INT)
**    #pragma section interrupt_fast end
**    #endif
**
**  Modules:
**       ProcessorExpert
**       Events
**
** ###################################################################
*/

/*
** ===================================================================
**     Method      :  SPI1_Init (component Init_SPI)
**
**     Description :
**         This method initializes registers of the SPI module
**         according to this Peripheral Initialization Bean settings.
**         Call this method in the user code to initialize the
**         module. By default, the method is called by PE
**         automatically; see "Call Init method" property of the
**         bean for more details.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void SPI1_Init(void)
{
  /* QSPI0_SPSCR: SPE=0 */
  clrReg16Bits(QSPI0_SPSCR, 0x20U);    /* Disable device */ 
  /* QSPI0_SPDSR: WOM=0,TDMAEN=0,RDMAEN=0,BD2X=0,SSB_IN=0,SSB_DATA=1,SSB_ODM=0,SSB_AUTO=0,SSB_DDR=0,SSB_STRB=0,SSB_OVER=0,SPR3=0,DS=7 */
  setReg16(QSPI0_SPDSR, 0x0407U);      /* Set data size and control register */ 
  /* QSPI0_SPWAIT: ??=0,??=0,??=0,WAIT=0 */
  setReg16(QSPI0_SPWAIT, 0x00U);       /* Set word delay register */ 
  /* QSPI0_SPFIFO: ??=0,TFCNT=0,??=0,RFCNT=0,??=0,TFWM=0,??=0,RFWM=3,??=0,FIFO_ENA=0 */
  setReg16(QSPI0_SPFIFO, 0x0CU);       /* Set FIFO control register */ 
  /* QSPI0_SPCTL2: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,SHEN=0 */
  setReg16(QSPI0_SPCTL2, 0x00U);       /* Set control register */ 
  /* QSPI0_SPSCR: SPR=3,DSO=0,ERRIE=0,MODFEN=0,SPRIE=0,SPMSTR=1,CPOL=0,CPHA=1,SPE=0,SPTIE=0,SPRF=0,OVRF=0,MODF=0,SPTE=0 */
  setReg16(QSPI0_SPSCR, 0x6140U);      /* Set control register */ 
  getReg(QSPI0_SPSCR);
  getReg(QSPI0_SPDRR);                 /* Clear flags */
  /* QSPI0_SPSCR: SPE=1 */
  setReg16Bits(QSPI0_SPSCR, 0x20U);    /* Enable device */ 
}

/* END SPI1. */

/*
** ###################################################################
**
**     This file was created by Processor Expert 5.3 [05.01]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
