/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : EInt1.c
**     Project     : ProcessorExpert
**     Processor   : MC56F84789VLL
**     Component   : ExtInt
**     Version     : Component 02.101, Driver 02.06, CPU db: 3.50.001
**     Compiler    : Metrowerks DSP C Compiler
**     Date/Time   : 2012-03-27, 15:13, # CodeGen: 2
**     Abstract    :
**         This component "ExtInt" implements an external 
**         interrupt, its control methods and interrupt/event 
**         handling procedure.
**         The component uses one pin which generates interrupt on 
**         selected edge.
**     Settings    :
**         Interrupt name              : INT_GPIOF
**         User handling procedure     : EInt1_OnInterrupt
**
**         Used pin                    :
**             ----------------------------------------------------
**                Number (on package)  |    Name
**             ----------------------------------------------------
**                       94            |  GPIOF6/TB2/PWMA_3X/PWMB_3X/XB_IN2
**             ----------------------------------------------------
**
**         Port name                   : GPIOF_Low
**
**         Bit number (in port)        : 6
**         Bit mask of the port        : 0040
**
**         Signal edge/level           : falling
**         Priority                    : 0
**         Pull option                 : off
**         Initial state               : Enabled
**
**         Edge register               : GPIOF_IPOLR [E256]
**         Enable register             : GPIOF_IENR [E255]
**         Request register            : GPIOF_IESR [E258]
**
**         Port data register          : GPIOF_DR  [E251]
**         Port control register       : GPIOF_DDR [E252]
**         Port function register      : GPIOF_PER [E253]
**     Contents    :
**         Enable  - void EInt1_Enable(void);
**         Disable - void EInt1_Disable(void);
**         GetVal  - bool EInt1_GetVal(void);
**
**     Copyright : 1997 - 2012 Freescale Semiconductor, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/

/* MODULE EInt1. */

#include "EInt1.h"
/*Including shared modules, which are used for all project*/
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
#include "Events.h"
#include "Cpu.h"


/*
** ===================================================================
**     Method      :  EInt1_Enable (component ExtInt)
**
**     Description :
**         Enable the component - the external events are accepted.
**         This method is available only if HW module allows
**         enable/disable of the interrupt.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void EInt1_Enable(void)
{
  setReg(GPIOF_IESR,EInt1_PIN_MASK);   /* Clear flag */
  setRegBits(GPIOF_IENR,EInt1_PIN_MASK); /* Enable interrupt "INT_GPIOF" */
}

/*
** ===================================================================
**     Method      :  EInt1_Disable (component ExtInt)
**
**     Description :
**         Disable the component - the external events are not accepted.
**         This method is available only if HW module allows
**         enable/disable of the interrupt.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void EInt1_Disable(void)

**  This method is implemented as a macro. See EInt1.h file.  **

*/

/*
** ===================================================================
**     Method      :  EInt1_GetVal (component ExtInt)
**
**     Description :
**         Returns the actual value of the input pin of the component.
**     Parameters  : None
**     Returns     :
**         ---             - Returned input value. Possible values:
**                           <false> - logical "0" (Low level) <true> -
**                           logical "1" (High level)
** ===================================================================
*/
/*
bool EInt1_GetVal(void)

**      This method is implemented as macro      **
*/

/* END EInt1. */

/*
** ###################################################################
**
**     This file was created by Processor Expert 5.3 [05.01]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
