/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : FMSTR1.h
**     Project     : ProcessorExpert
**     Processor   : MC56F84789VLL
**     Component   : FreeMaster
**     Version     : Component 01.006, Driver 01.03, CPU db: 3.50.001
**     Compiler    : Metrowerks DSP C Compiler
**     Date/Time   : 2012-03-19, 22:52, # CodeGen: 1
**     Abstract    :
**          This component encapsulates the FreeMASTER driver. The FreeMASTER
**          driver implements all the features necessary to establish a communication
**          with the FreeMASTER visualization tool.
**     Settings    :
**          Init_SCI                             : Inhr1
**
**          Initialization:
**              Driver interrupt mode            : Polling mode 
**              Communication device             : SCI
**              Oscilloscope enabled             : yes
**              Recorder enabled                 : yes
**              Recorder buffer length           : 2500
**              Application command enabled      : no
**              Command buffer length            : 16
**              TSA enabled                      : no
**              Read/write memory commands       : yes
**              Read/write variable commands     : no
**              Data buffer length               : 60
**     Contents    :
**         Poll       - void FMSTR1_Poll(void);
**         Recorder   - void FMSTR1_Recorder(void);
**         TriggerRec - void FMSTR1_TriggerRec(void);
**
**     (c) Freescale Semiconductor
**     2004 All Rights Reserved
**
**     Copyright : 1997 - 2012 Freescale Semiconductor, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/

#ifndef __FMSTR1
#define __FMSTR1

/* MODULE FMSTR1. */

/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
/* Include inherited beans */
#include "Inhr1.h"
#include "Cpu.h"

/* FreeMASTER Driver main API header file */
#include "PE_freemaster.h"


#define FMSTR1_Init(void) FMSTR_Init(void)
/*
** ===================================================================
**     Method      :  FMSTR1_Init (component FreeMaster)
**
**     Description :
**         This function initializes internal variables of the FreeMASTER 
**         driver and enables the communication interface (SCI or JTAG). 
**         The method is called automatically as a part of the 
**         application initialization code.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

#define FMSTR1_Poll(void) FMSTR_Poll(void)
/*
** ===================================================================
**     Method      :  FMSTR1_Poll (component FreeMaster)
**
**     Description :
**         In the poll-driven or short interrupt modes, this function
**         handles the protocol decoding and execution. In the
**         poll-driven mode, this function also handles the SCI
**         communication. In the long interrupt mode, this function
**         compiles as an empty function and may still be called.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

#define FMSTR1_Isr FMSTR_Isr
/*
** ===================================================================
**     Method      :  FMSTR1_Isr (component FreeMaster)
**
**     Description :
**         Main SCI/JTAG Interrupt handler call. This Interrupt Service 
**         Routine handles the interrupts for the FreeMASTER driver.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

#define FMSTR1_Recorder(void) FMSTR_Recorder(void)
/*
** ===================================================================
**     Method      :  FMSTR1_Recorder (component FreeMaster)
**
**     Description :
**         Recorder worker routine. This returns quickly if recorder is
**         not running, otherwise it calls quite lengthy recorder
**         routine which does all the recorder work (sampling,
**         triggering). 
**         This method is enabled only if the Recorder property is
**         enabled.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

#define FMSTR1_TriggerRec(void) FMSTR_TriggerRec(void)
/*
** ===================================================================
**     Method      :  FMSTR1_TriggerRec (component FreeMaster)
**
**     Description :
**         Pull the trigger of the recorder. This function starts the
**         post-trigger stop countdown.
**         This method is enabled only if the Recorder property is
**         enabled.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/


/* END FMSTR1. */

#endif                                 /* ifndef __FMSTR1 */

/*
** ###################################################################
**
**     This file was created by Processor Expert 5.3 [05.01]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
